Index: PROJECT_CORE_MPI/CORE_MPI/BRANCHES/v0.01/MultiMPITest_summary.html
===================================================================
--- PROJECT_CORE_MPI/CORE_MPI/BRANCHES/v0.01/MultiMPITest_summary.html	(revision 35)
+++ PROJECT_CORE_MPI/CORE_MPI/BRANCHES/v0.01/MultiMPITest_summary.html	(revision 39)
@@ -3,9 +3,10 @@
 <TABLE BORDER CELLSPACING=0 CELLPADDING=3 WIDTH='100%'>
 <TR ALIGN=CENTER BGCOLOR='#99CCFF'>
-<TD ALIGN=CENTER COLSPAN='4'><B>MultiMPITest Project Status</B></TD></TR>
+<TD ALIGN=CENTER COLSPAN='4'><B>MultiMPITest Project Status (12/05/2012 - 14:37:41)</B></TD></TR>
 <TR ALIGN=LEFT>
 <TD BGCOLOR='#FFFF99'><B>Project File:</B></TD>
 <TD>MPI_CORE_COMPONENTS.xise</TD>
 <TD BGCOLOR='#FFFF99'><b>Parser Errors:</b></TD>
+<TD> No Errors </TD>
 </TR>
 <TR ALIGN=LEFT>
@@ -13,5 +14,5 @@
 <TD>MultiMPITest</TD>
 <TD BGCOLOR='#FFFF99'><B>Implementation State:</B></TD>
-<TD>New</TD>
+<TD>Synthesized (Failed)</TD>
 </TR>
 <TR ALIGN=LEFT>
@@ -19,10 +20,12 @@
 <TD>xc6slx100-3fgg484</TD>
 <TD BGCOLOR='#FFFF99'><UL><LI><B>Errors:</B></LI></UL></TD>
-<TD>&nbsp;</TD>
+<TD>
+<font color="red"; face="Arial"><b>X </b></font>
+<A HREF_DISABLED='C:/Core MPI/CORE_MPI\_xmsgs/*.xmsgs?&DataKey=Error'>3 Errors (3 new)</A></TD>
 </TR>
 <TR ALIGN=LEFT>
 <TD BGCOLOR='#FFFF99'><B>Product Version:</B></TD><TD>ISE 12.3</TD>
 <TD BGCOLOR='#FFFF99'><UL><LI><B>Warnings:</B></LI></UL></TD>
-<TD>&nbsp;</TD>
+<TD ALIGN=LEFT><A HREF_DISABLED='C:/Core MPI/CORE_MPI\_xmsgs/*.xmsgs?&DataKey=Warning'>71 Warnings (71 new)</A></TD>
 </TR>
 <TR ALIGN=LEFT>
@@ -41,5 +44,8 @@
 <TR ALIGN=LEFT>
 <TD BGCOLOR='#FFFF99'><B>Environment:</B></dif></TD>
-<TD>&nbsp;</TD>
+<TD>
+<A HREF_DISABLED='C:/Core MPI/CORE_MPI\MultiMPITest_envsettings.html'>
+System Settings</A>
+</TD>
 <TD BGCOLOR='#FFFF99'><UL><LI><B>Final Timing Score:</B></LI></UL></TD>
 <TD>&nbsp;&nbsp;</TD>
@@ -51,5 +57,55 @@
 &nbsp;<BR><TABLE BORDER CELLSPACING=0 CELLPADDING=3 WIDTH='100%'>
 <TR ALIGN=CENTER BGCOLOR='#99CCFF'><TD ALIGN=CENTER COLSPAN='2'><B>Current Warnings</B></TD><TD ALIGN=RIGHT WIDTH='10%'COLSPAN=1> <A HREF_DISABLED="?&ExpandedTable=CurrentWarnings"><B>[-]</B></a></TD></TR>
-<TR ALIGN=LEFT BGCOLOR='#FFFF99'><TD COLSPAN='3'><B>No Warnings Found</B></TD></TR>
+<TR ALIGN=LEFT BGCOLOR='#FFFF99'><TD><B>Synthesis Warnings (Only the first 50 listed)</B></TD><TD COLSPAN='2'><B>New</B></TD></TR>
+<TR ALIGN=LEFT><TD>WARNING:HDLCompiler:871: - "\Core MPI\CORE_MPI\../SWITCH_GENERIC_16_16/INPUT_PORT_MODULE.vhd" Line 114: Using initial value ('0','0','1','1','0','0','0','0') for port_id since it is never assigned</TD><TD COLSPAN='2'>New</TD></TR>
+<TR ALIGN=LEFT><TD>WARNING:HDLCompiler:92: - "\Core MPI\CORE_MPI\../SWITCH_GENERIC_16_16/INPUT_PORT_MODULE.vhd" Line 587: port_id should be on the sensitivity list of the process</TD><TD COLSPAN='2'>New</TD></TR>
+<TR ALIGN=LEFT><TD>WARNING:HDLCompiler:92: - "\Core MPI\CORE_MPI\../SWITCH_GENERIC_16_16/INPUT_PORT_MODULE.vhd" Line 596: port_id should be on the sensitivity list of the process</TD><TD COLSPAN='2'>New</TD></TR>
+<TR ALIGN=LEFT><TD>WARNING:HDLCompiler:871: - "\Core MPI\CORE_MPI\CORE_MPI.vhd" Line 333: Using initial value "00011010" for uclkrate since it is never assigned</TD><TD COLSPAN='2'>New</TD></TR>
+<TR ALIGN=LEFT><TD>WARNING:HDLCompiler:1127: - "\Core MPI\CORE_MPI\FIFO_64_FWFT.vhd" Line 103: Assignment to clk_signal ignored, since the identifier is never used</TD><TD COLSPAN='2'>New</TD></TR>
+<TR ALIGN=LEFT><TD>WARNING:HDLCompiler:1127: - "\Core MPI\CORE_MPI\FIFO_64_FWFT.vhd" Line 168: Assignment to doa_signal ignored, since the identifier is never used</TD><TD COLSPAN='2'>New</TD></TR>
+<TR ALIGN=LEFT><TD>WARNING:HDLCompiler:92: - "\Core MPI\CORE_MPI\load_instr.vhd" Line 187: base_adr should be on the sensitivity list of the process</TD><TD COLSPAN='2'>New</TD></TR>
+<TR ALIGN=LEFT><TD>WARNING:HDLCompiler:92: - "\Core MPI\CORE_MPI\load_instr.vhd" Line 215: ram_address_i should be on the sensitivity list of the process</TD><TD COLSPAN='2'>New</TD></TR>
+<TR ALIGN=LEFT><TD>WARNING:HDLCompiler:871: - "\Core MPI\CORE_MPI\Ex0_Fsm.vhd" Line 59: Using initial value '1' for en since it is never assigned</TD><TD COLSPAN='2'>New</TD></TR>
+<TR ALIGN=LEFT><TD>WARNING:HDLCompiler:92: - "\Core MPI\CORE_MPI\Ex0_Fsm.vhd" Line 149: clkrate should be on the sensitivity list of the process</TD><TD COLSPAN='2'>New</TD></TR>
+<TR ALIGN=LEFT><TD>WARNING:HDLCompiler:92: - "\Core MPI\CORE_MPI\Ex0_Fsm.vhd" Line 153: tick_count should be on the sensitivity list of the process</TD><TD COLSPAN='2'>New</TD></TR>
+<TR ALIGN=LEFT><TD>WARNING:HDLCompiler:92: - "\Core MPI\CORE_MPI\Ex0_Fsm.vhd" Line 154: clkr_count should be on the sensitivity list of the process</TD><TD COLSPAN='2'>New</TD></TR>
+<TR ALIGN=LEFT><TD>WARNING:HDLCompiler:92: - "\Core MPI\CORE_MPI\Ex0_Fsm.vhd" Line 155: clkr_count should be on the sensitivity list of the process</TD><TD COLSPAN='2'>New</TD></TR>
+<TR ALIGN=LEFT><TD>WARNING:HDLCompiler:92: - "\Core MPI\CORE_MPI\Ex0_Fsm.vhd" Line 156: tick_count should be on the sensitivity list of the process</TD><TD COLSPAN='2'>New</TD></TR>
+<TR ALIGN=LEFT><TD>WARNING:HDLCompiler:92: - "\Core MPI\CORE_MPI\Ex0_Fsm.vhd" Line 158: time_ucount should be on the sensitivity list of the process</TD><TD COLSPAN='2'>New</TD></TR>
+<TR ALIGN=LEFT><TD>WARNING:HDLCompiler:92: - "\Core MPI\CORE_MPI\Ex0_Fsm.vhd" Line 159: clkrate should be on the sensitivity list of the process</TD><TD COLSPAN='2'>New</TD></TR>
+<TR ALIGN=LEFT><TD>WARNING:HDLCompiler:92: - "\Core MPI\CORE_MPI\Ex0_Fsm.vhd" Line 160: tick_count should be on the sensitivity list of the process</TD><TD COLSPAN='2'>New</TD></TR>
+<TR ALIGN=LEFT><TD>WARNING:HDLCompiler:92: - "\Core MPI\CORE_MPI\Ex0_Fsm.vhd" Line 161: tick_count should be on the sensitivity list of the process</TD><TD COLSPAN='2'>New</TD></TR>
+<TR ALIGN=LEFT><TD>WARNING:HDLCompiler:92: - "\Core MPI\CORE_MPI\Ex0_Fsm.vhd" Line 163: time_ucount should be on the sensitivity list of the process</TD><TD COLSPAN='2'>New</TD></TR>
+<TR ALIGN=LEFT><TD>WARNING:HDLCompiler:92: - "\Core MPI\CORE_MPI\Ex0_Fsm.vhd" Line 165: tick_count should be on the sensitivity list of the process</TD><TD COLSPAN='2'>New</TD></TR>
+<TR ALIGN=LEFT><TD>WARNING:HDLCompiler:92: - "\Core MPI\CORE_MPI\Ex0_Fsm.vhd" Line 166: clkr_count should be on the sensitivity list of the process</TD><TD COLSPAN='2'>New</TD></TR>
+<TR ALIGN=LEFT><TD>WARNING:HDLCompiler:92: - "\Core MPI\CORE_MPI\Ex0_Fsm.vhd" Line 167: time_ucount should be on the sensitivity list of the process</TD><TD COLSPAN='2'>New</TD></TR>
+<TR ALIGN=LEFT><TD>WARNING:HDLCompiler:92: - "\Core MPI\CORE_MPI\Ex0_Fsm.vhd" Line 168: tick_count should be on the sensitivity list of the process</TD><TD COLSPAN='2'>New</TD></TR>
+<TR ALIGN=LEFT><TD>WARNING:HDLCompiler:92: - "\Core MPI\CORE_MPI\EX1_FSM.vhd" Line 665: rd_ok should be on the sensitivity list of the process</TD><TD COLSPAN='2'>New</TD></TR>
+<TR ALIGN=LEFT><TD>WARNING:HDLCompiler:92: - "\Core MPI\CORE_MPI\EX1_FSM.vhd" Line 667: rd_ok should be on the sensitivity list of the process</TD><TD COLSPAN='2'>New</TD></TR>
+<TR ALIGN=LEFT><TD>WARNING:HDLCompiler:1127: - "\Core MPI\CORE_MPI\EX2_FSM.vhd" Line 100: Assignment to pading_data ignored, since the identifier is never used</TD><TD COLSPAN='2'>New</TD></TR>
+<TR ALIGN=LEFT><TD>WARNING:HDLCompiler:92: - "\Core MPI\CORE_MPI\EX2_FSM.vhd" Line 468: data_to_ram should be on the sensitivity list of the process</TD><TD COLSPAN='2'>New</TD></TR>
+<TR ALIGN=LEFT><TD>WARNING:HDLCompiler:92: - "\Core MPI\CORE_MPI\EX2_FSM.vhd" Line 481: data_to_ram should be on the sensitivity list of the process</TD><TD COLSPAN='2'>New</TD></TR>
+<TR ALIGN=LEFT><TD>WARNING:HDLCompiler:92: - "\Core MPI\CORE_MPI\EX2_FSM.vhd" Line 496: wr_ok should be on the sensitivity list of the process</TD><TD COLSPAN='2'>New</TD></TR>
+<TR ALIGN=LEFT><TD>WARNING:HDLCompiler:92: - "\Core MPI\CORE_MPI\EX2_FSM.vhd" Line 497: wr_ok should be on the sensitivity list of the process</TD><TD COLSPAN='2'>New</TD></TR>
+<TR ALIGN=LEFT><TD>WARNING:HDLCompiler:92: - "\Core MPI\CORE_MPI\EX2_FSM.vhd" Line 501: data_to_ram should be on the sensitivity list of the process</TD><TD COLSPAN='2'>New</TD></TR>
+<TR ALIGN=LEFT><TD>WARNING:HDLCompiler:92: - "\Core MPI\CORE_MPI\EX2_FSM.vhd" Line 511: wr_ok should be on the sensitivity list of the process</TD><TD COLSPAN='2'>New</TD></TR>
+<TR ALIGN=LEFT><TD>WARNING:HDLCompiler:92: - "\Core MPI\CORE_MPI\EX2_FSM.vhd" Line 513: wr_ok should be on the sensitivity list of the process</TD><TD COLSPAN='2'>New</TD></TR>
+<TR ALIGN=LEFT><TD>WARNING:HDLCompiler:92: - "\Core MPI\CORE_MPI\EX2_FSM.vhd" Line 514: data_to_ram should be on the sensitivity list of the process</TD><TD COLSPAN='2'>New</TD></TR>
+<TR ALIGN=LEFT><TD>WARNING:HDLCompiler:92: - "\Core MPI\CORE_MPI\EX2_FSM.vhd" Line 537: wr_ok should be on the sensitivity list of the process</TD><TD COLSPAN='2'>New</TD></TR>
+<TR ALIGN=LEFT><TD>WARNING:HDLCompiler:92: - "\Core MPI\CORE_MPI\EX2_FSM.vhd" Line 568: wr_ok should be on the sensitivity list of the process</TD><TD COLSPAN='2'>New</TD></TR>
+<TR ALIGN=LEFT><TD>WARNING:HDLCompiler:92: - "\Core MPI\CORE_MPI\EX2_FSM.vhd" Line 570: wr_ok should be on the sensitivity list of the process</TD><TD COLSPAN='2'>New</TD></TR>
+<TR ALIGN=LEFT><TD>WARNING:HDLCompiler:92: - "\Core MPI\CORE_MPI\EX2_FSM.vhd" Line 571: data_to_ram should be on the sensitivity list of the process</TD><TD COLSPAN='2'>New</TD></TR>
+<TR ALIGN=LEFT><TD>WARNING:HDLCompiler:871: - "\Core MPI\CORE_MPI\EX3_FSM.vhd" Line 51: Using initial value "00000011" for size since it is never assigned</TD><TD COLSPAN='2'>New</TD></TR>
+<TR ALIGN=LEFT><TD>WARNING:HDLCompiler:1127: - "\Core MPI\CORE_MPI\EX4_FSM.vhd" Line 126: Assignment to ranksent ignored, since the identifier is never used</TD><TD COLSPAN='2'>New</TD></TR>
+<TR ALIGN=LEFT><TD>WARNING:HDLCompiler:92: - "\Core MPI\CORE_MPI\EX4_FSM.vhd" Line 224: bcast_rdy should be on the sensitivity list of the process</TD><TD COLSPAN='2'>New</TD></TR>
+<TR ALIGN=LEFT><TD>WARNING:HDLCompiler:92: - "\Core MPI\CORE_MPI\EX4_FSM.vhd" Line 243: bcast_rdy should be on the sensitivity list of the process</TD><TD COLSPAN='2'>New</TD></TR>
+<TR ALIGN=LEFT><TD>WARNING:HDLCompiler:92: - "\Core MPI\CORE_MPI\EX4_FSM.vhd" Line 316: portnum_i should be on the sensitivity list of the process</TD><TD COLSPAN='2'>New</TD></TR>
+<TR ALIGN=LEFT><TD>WARNING:HDLCompiler:92: - "\Core MPI\CORE_MPI\EX4_FSM.vhd" Line 318: nextrank should be on the sensitivity list of the process</TD><TD COLSPAN='2'>New</TD></TR>
+<TR ALIGN=LEFT><TD>WARNING:HDLCompiler:92: - "\Core MPI\CORE_MPI\EX4_FSM.vhd" Line 340: send_rdy should be on the sensitivity list of the process</TD><TD COLSPAN='2'>New</TD></TR>
+<TR ALIGN=LEFT><TD>WARNING:HDLCompiler:92: - "\Core MPI\CORE_MPI\EX4_FSM.vhd" Line 368: datatosend should be on the sensitivity list of the process</TD><TD COLSPAN='2'>New</TD></TR>
+<TR ALIGN=LEFT><TD>WARNING:HDLCompiler:92: - "\Core MPI\CORE_MPI\EX4_FSM.vhd" Line 384: exectime_out should be on the sensitivity list of the process</TD><TD COLSPAN='2'>New</TD></TR>
+<TR ALIGN=LEFT><TD>WARNING:HDLCompiler:1127: - "\Core MPI\CORE_MPI\EX4_FSM.vhd" Line 143: Assignment to cm_ack ignored, since the identifier is never used</TD><TD COLSPAN='2'>New</TD></TR>
+<TR ALIGN=LEFT><TD>WARNING:HDLCompiler:871: - "\Core MPI\CORE_MPI\EX4_FSM.vhd" Line 433: Using initial value "0000" for nulvect since it is never assigned</TD><TD COLSPAN='2'>New</TD></TR>
+<TR ALIGN=LEFT><TD>WARNING:HDLCompiler:92: - "\Core MPI\CORE_MPI\EX4_FSM.vhd" Line 484: exectime_out should be on the sensitivity list of the process</TD><TD COLSPAN='2'>New</TD></TR>
 </TABLE>
 
@@ -70,5 +126,5 @@
 <TR BGCOLOR='#FFFF99'><TD><B>Report Name</B></TD><TD><B>Status</B></TD><TD><B>Generated</B></TD>
 <TD ALIGN=LEFT><B>Errors</B></TD><TD ALIGN=LEFT><B>Warnings</B></TD><TD ALIGN=LEFT COLSPAN='2'><B>Infos</B></TD></TR>
-<TR ALIGN=LEFT><TD>Synthesis Report</TD><TD>&nbsp;</TD><TD>&nbsp;</TD><TD>&nbsp;</TD><TD>&nbsp;</TD><TD COLSPAN='2'>&nbsp;</TD></TR>
+<TR ALIGN=LEFT><TD><A HREF_DISABLED='C:/Core MPI/CORE_MPI\MultiMPITest.syr'>Synthesis Report</A></TD><TD>Current</TD><TD>Wed 5. Dec 14:37:20 2012</TD><TD ALIGN=LEFT><font color="red"; face="Arial"><b>X </b></font><A HREF_DISABLED='C:/Core MPI/CORE_MPI\_xmsgs/xst.xmsgs?&DataKey=Error'>3 Errors (3 new)</A></TD><TD ALIGN=LEFT><A HREF_DISABLED='C:/Core MPI/CORE_MPI\_xmsgs/xst.xmsgs?&DataKey=Warning'>71 Warnings (71 new)</A></TD><TD ALIGN=LEFT COLSPAN='2'>0</TD></TR>
 <TR ALIGN=LEFT><TD>Translation Report</TD><TD>&nbsp;</TD><TD>&nbsp;</TD><TD>&nbsp;</TD><TD>&nbsp;</TD><TD COLSPAN='2'>&nbsp;</TD></TR>
 <TR ALIGN=LEFT><TD>Map Report</TD><TD>&nbsp;</TD><TD>&nbsp;</TD><TD>&nbsp;</TD><TD>&nbsp;</TD><TD COLSPAN='2'>&nbsp;</TD></TR>
@@ -81,5 +137,5 @@
 <TR ALIGN=CENTER BGCOLOR='#99CCFF'><TD ALIGN=CENTER COLSPAN='3'><B>Secondary Reports</B></TD><TD ALIGN=RIGHT WIDTH='10%'COLSPAN=1> <A HREF_DISABLED="?&ExpandedTable=SecondaryReports"><B>[-]</B></a></TD></TR>
 <TR BGCOLOR='#FFFF99'><TD><B>Report Name</B></TD><TD><B>Status</B></TD><TD COLSPAN='2'><B>Generated</B></TD></TR>
-<TR ALIGN=LEFT><TD><A HREF_DISABLED='C:/Core MPI/CORE_MPI\isim.log'>ISIM Simulator Log</A></TD><TD>Out of Date</TD><TD COLSPAN='2'>Mon 3. Dec 14:50:28 2012</TD></TR>
+<TR ALIGN=LEFT><TD><A HREF_DISABLED='C:/Core MPI/CORE_MPI\isim.log'>ISIM Simulator Log</A></TD><TD>Out of Date</TD><TD COLSPAN='2'>Wed 5. Dec 14:35:53 2012</TD></TR>
 <TR ALIGN=LEFT><TD><A HREF_DISABLED='C:/Core MPI/CORE_MPI\usage_statistics_webtalk.html'>WebTalk Report</A></TD><TD>Out of Date</TD><TD COLSPAN='2'>Fri 17. Aug 16:33:25 2012</TD></TR>
 <TR ALIGN=LEFT><TD><A HREF_DISABLED='C:/Core MPI/CORE_MPI\webtalk.log'>WebTalk Log File</A></TD><TD>Out of Date</TD><TD COLSPAN='2'>Fri 17. Aug 16:33:28 2012</TD></TR>
@@ -87,4 +143,4 @@
 
 
-<br><center><b>Date Generated:</b> 12/03/2012 - 14:51:10</center>
+<br><center><b>Date Generated:</b> 12/05/2012 - 14:39:46</center>
 </BODY></HTML>