Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Component.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Component.h	(revision 42)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Component.h	(revision 42)
@@ -0,0 +1,88 @@
+#ifndef morpheo_behavioural_Component_h
+#define morpheo_behavioural_Component_h
+
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include <stdint.h>
+#include <iostream>
+#include <list>
+#include <map>
+#ifdef VHDL
+#include "Behavioural/include/Vhdl.h"
+#endif
+//#include "Behavioural/include/Description.h"
+#include "Behavioural/include/Entity.h"
+#include "Include/ToString.h"
+#include "Include/Debug.h"
+
+using namespace std;
+
+namespace morpheo              {
+namespace behavioural          {
+
+  class Component
+  {
+    // -----[ fields ]----------------------------------------------------
+  private   : Entity              * _entity        ;
+  private   : list<Entity *>      * _list_component;
+    
+    // -----[ methods ]---------------------------------------------------
+  public    :                       Component         (void);
+  public    :                       Component         (const Component & component);
+  public    :                       ~Component        ();
+
+  public    : Entity *              set_entity        (string        name   
+						       ,string        type  
+#ifdef POSITION
+						       ,schema_t      schema
+#endif
+						       );
+  private   : string                get_entity        (void);
+
+  public    : void                  set_component     (Component * component
+#ifdef POSITION
+						       ,uint32_t   pos_x  
+						       ,uint32_t   pos_y  
+						       ,uint32_t   size_x 
+						       ,uint32_t   size_y 
+#endif
+						       );
+
+  private   : string                get_component     (void);
+
+  private   : Entity *              find_entity       (string name);
+  private   : Interface *           find_interface    (string   name  , 
+						       Entity * entity);
+
+#ifdef VHDL
+  public    : void                  vhdl_instance     (Vhdl * & vhdl);
+#endif
+
+  public    : void                  port_map          (string component_src ,
+						       string port_src      ,
+						       string component_dest,
+						       string port_dest    );
+
+#ifdef POSITION
+  public    : void                  interface_map     (string component_src ,
+						       string port_dest,
+						       string component_dest,
+						       string port_dest     );
+
+  public    : XML                   toXML             (void);
+
+  public    : void                  generate_file     (void);
+#endif    
+  public    : friend ostream&       operator<<        (ostream& output_stream,
+  					  	       morpheo::behavioural::Component & x);
+  };
+
+}; // end namespace behavioural          
+}; // end namespace morpheo              
+
+#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Direction.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Direction.h	(revision 41)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Direction.h	(revision 42)
@@ -7,6 +7,6 @@
 namespace behavioural          {
 
-typedef enum { IN, OUT } direction_t;
-  //typedef enum { IN, OUT, INOUT } direction_t;
+typedef enum {INTERNAL, IN, OUT } direction_t;
+//typedef enum { IN, OUT, INOUT } direction_t;
 
 }; // end namespace behavioural          
@@ -16,7 +16,8 @@
     switch (x)
       {
-      case morpheo::behavioural::IN    : return "in"    ; break;
-      case morpheo::behavioural::OUT   : return "out"   ; break;
-//    case morpheo::behavioural::INOUT : return "inout" ; break;
+      case morpheo::behavioural::INTERNAL : return "internal" ; break;
+      case morpheo::behavioural::IN       : return "in"       ; break;
+      case morpheo::behavioural::OUT      : return "out"      ; break;
+//    case morpheo::behavioural::INOUT    : return "inout"    ; break;
       default    : return ""      ; break;
       }
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Entity.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Entity.h	(revision 41)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Entity.h	(revision 42)
@@ -1,3 +1,2 @@
-#ifdef POSITION
 #ifndef morpheo_behavioural_Entity_h
 #define morpheo_behavioural_Entity_h
@@ -13,4 +12,5 @@
 #include <iostream>
 #include <list>
+//#include "Behavioural/include/Description.h"
 #include "Behavioural/include/Interfaces.h"
 #include "Behavioural/include/Schema.h"
@@ -26,12 +26,13 @@
   class Entity
   {
-    friend class Position;
-    friend class Interface;
-
     // -----[ fields ]----------------------------------------------------
   private   : const string          _name         ;
   private   : const string          _type         ;
+#ifdef POSITION
   private   : const schema_t        _schema       ;
+#endif
   private   : Interfaces          * _interfaces   ;
+
+#ifdef POSITION
   private   : string                _comment      ;
 
@@ -41,28 +42,42 @@
   private   :       uint32_t        _map_pos_x    ;
   private   :       uint32_t        _map_pos_y    ;
+#endif
 
     // -----[ methods ]---------------------------------------------------
-  public    :                       Entity            (string        name   ,
-						       string        type   ,
-						       schema_t      schema );
+  public    :                       Entity            ( string        name   
+						       ,string        type   
+#ifdef POSITION
+						       ,schema_t      schema 
+#endif
+							);
   public    :                        Entity           (const Entity & entity);
   public    :                       ~Entity           ();
 
+  public    : string                get_name          (void);
+  public    : string                get_type          (void);
+
+#ifdef POSITION
   public    : void                  set_comment       (string comment);
   private   : string                get_comment       (void          );
-
+#endif
   public    : Interfaces *          set_interfaces    (void);
   private   : string                get_interfaces    (void);
+  public    : Interfaces *          get_interfaces_list(void);
 
   public    : Interface  *          find_interface    (string name);
+  public    : Signal     *          find_signal       (string name);
+  public    : bool                  find_signal       (Signal * signal);
 
+#ifdef POSITION
   public    : void                  mapping           (uint32_t pos_x,
 						       uint32_t pos_y,
 						       uint32_t size_x ,
 						       uint32_t size_y );
+#endif
 
+#ifdef POSITION
   public    : XML                   toXML             (void);
   public    : XML                   toXML_mapping     (void);
-
+#endif
   public    : friend ostream&       operator<<        (ostream& output_stream,
   					  	       morpheo::behavioural::Entity & x);
@@ -73,3 +88,2 @@
 
 #endif
-#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Environnement.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Environnement.h	(revision 41)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Environnement.h	(revision 42)
@@ -10,2 +10,7 @@
 #  error "To have the vhdl's test bench, you must set flags VHDL"
 #endif
+
+#if (defined(VHDL_TESTBENCH_ASSERT) and not defined(VHDL_TESTBENCH))
+#  error "To have an assert in vhdl's test bench, you must set flags VHDL_TESTBENCH"
+#endif
+
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Interface.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Interface.h	(revision 41)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Interface.h	(revision 42)
@@ -33,11 +33,11 @@
   class Interface
   {
-    friend class Interfaces;
-
     // -----[ fields ]----------------------------------------------------
   protected : const string          _name         ;
+#ifdef POSITION
   protected : const direction_t     _direction    ;
   protected : const localisation_t  _localisation ;
   protected :       string          _comment      ;
+#endif
 
   protected : list<Signal *>      * _list_signal  ;
@@ -54,17 +54,27 @@
     
     // -----[ methods ]---------------------------------------------------
-  public    :                       Interface            (string         name        ,
-							  direction_t    direction   ,
-							  localisation_t localisation);
+  public    :                       Interface            (string         name        
+#ifdef POSITION
+							  ,direction_t    direction   
+							  ,localisation_t localisation
+#endif
+							  );
 
   public    :                       Interface            (const Interface    & interface);
   public    :                       ~Interface           ();
 
+  public    : string                get_name             ();
+
+#ifdef POSITION
   public    : void                  set_comment          (string comment);
   protected : string                get_comment          (void          );
+#endif
 
   protected : string                signal_name          (string      name_interface,
 							  string      name_signal   ,
 							  direction_t direction     );
+
+  public    : Signal *              find_signal          (string name);
+  public    : bool                  find_signal          (Signal * signal);
 
   protected : string                get_signal           (void);
@@ -73,4 +83,5 @@
 							  uint32_t        size     ,
 							  presence_port_t presence_port = PORT_VHDL_YES_TESTBENCH_YES);
+  public    : list<Signal *>      * get_signal_list      (void);
 
 #ifdef SYSTEMC
@@ -85,10 +96,12 @@
 	throw ErrorMorpheo ("Signal \""+name+"\" is a clock, bad presence_port.");
 
-      Signal    * sig    = set_signal (name, IN , size, presence_port);
-      sc_in_clk * signal = new sc_in_clk (sig->_name.c_str());
+      Signal    * sig  = set_signal (name, IN , size, presence_port);
+      sc_in_clk * port = new sc_in_clk (sig->_name.c_str());
+
+      sig->alloc<bool> (static_cast<void *>(port));
 
       log_printf(FUNC,Behavioural,"set_signal_clk","End");
 
-      return signal;
+      return port;
     };
 
@@ -104,9 +117,8 @@
 	throw ErrorMorpheo ("Signal \""+name+"\" is not a clock, bad presence_port.");
 
-      Signal * sig = set_signal (name, IN , size, presence_port);
+      Signal    * sig  = set_signal (name, IN , size, presence_port);
       sc_in <T> * port = new sc_in <T> (sig->_name.c_str());
-#ifdef VHDL_TESTBENCH
+
       sig->alloc<T> (static_cast<void *>(port));
-#endif
 
       log_printf(FUNC,Behavioural,"set_signal_in","End");
@@ -128,7 +140,6 @@
       Signal * sig = set_signal (name, OUT , size, presence_port);
       sc_out <T> * port = new sc_out <T> (sig->_name.c_str());
-#ifdef VHDL_TESTBENCH
+
       sig->alloc<T> (static_cast<void *>(port));
-#endif
 
       log_printf(FUNC,Behavioural,"set_signal_out","End");
@@ -136,36 +147,53 @@
       return port;
     };
+
+  public    : template <typename T>
+              sc_signal <T> *       set_signal_internal (string   name,
+							 uint32_t size)
+    {
+      log_printf(FUNC,Behavioural,"set_signal_internal","Begin");
+
+      Signal * sig = set_signal (name, INTERNAL , size, PORT_VHDL_NO_TESTBENCH_NO);
+      sc_signal <T> * port = new sc_signal <T> (sig->_name.c_str());
+
+      sig->alloc<T> (static_cast<void *>(port));
+
+      log_printf(FUNC,Behavioural,"set_signal_internal","End");
+
+      return port;
+    };
+
 #endif
 
 #ifdef VHDL
   public    : void                  set_port             (Vhdl * & vhdl);
-#ifdef VHDL_TESTBENCH
+#  ifdef VHDL_TESTBENCH
   public    : void                  set_signal           (Vhdl * & vhdl);
   public    : void                  get_signal           (list<string> * & list_signal);
-#endif
+#  endif
 #endif
 #ifdef VHDL_TESTBENCH
   public    : uint32_t              get_cycle            (void);
-  public    : string                get_clock            (void);
+  public    : Signal *              get_clock            (void);
+  public    : Signal *              get_reset            (void);
 
   public    : void                  testbench            (void);
   public    : void                  testbench_cycle      (void);
   public    : void                  testbench_body       (Vhdl           * & vhdl          ,
-							  string             counter_name  );
+							  string             counter_name  ,
+							  string             reset_name    );
   public    : string                testbench_test       (Vhdl           * & vhdl        ,
-							  string             counter_name);
+							  string             counter_name,
+							  string             reset_name);
   public    : string                testbench_test_ok    (Vhdl           * & vhdl        );
   protected : string                testbench_test_name   (Vhdl           * & vhdl);
   protected : string                testbench_test_ok_name(Vhdl           * & vhdl);
-
-#endif
-
-#ifdef POSITION
-  public    : void                  port_map             (void * entity,
+  protected : string                testbench_test_transaction_name(Vhdl           * & vhdl);
+#endif
+
+#ifdef POSITION
+  public    : void                  interface_map        (void * entity,
 							  void * interface);
-#endif
-
   public    : XML                   toXML                (void);
-#ifdef POSITION
   public    : XML                   toXML_mapping        (void);
 #endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Interface_fifo.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Interface_fifo.h	(revision 41)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Interface_fifo.h	(revision 42)
@@ -24,11 +24,13 @@
   private   : bool                  _test_exhaustive;
   private   : list<uint32_t>      * _list_cycle   ;
-
 #endif
 
    // -----[ methods ]---------------------------------------------------
-  public    :                       Interface_fifo       (string         name        ,
-							  direction_t    direction   ,
-							  localisation_t localisation);
+  public    :                       Interface_fifo       (string         name        
+#ifdef POSITION
+							  ,direction_t    direction   
+							  ,localisation_t localisation
+#endif
+							  );
     
   public    :                       Interface_fifo       (const Interface_fifo & interface_fifo);
@@ -79,6 +81,9 @@
   public    : bool                  testbench_transaction(void);
   public    : void                  testbench_cycle      (void);
-  public    : string                testbench_test       (Vhdl           * & vhdl        ,
-							  string             counter_name);
+  public    : string                testbench_test       (Vhdl   * & vhdl        ,
+							  string     counter_name,
+							  string     reset_name  );
+
+  public    : string                testbench_test_transaction (Vhdl * & vhdl);
 #endif
   };
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Interfaces.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Interfaces.h	(revision 41)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Interfaces.h	(revision 42)
@@ -35,12 +35,18 @@
   public    :                       ~Interfaces           ();
 
-  public    : Interface_fifo *      set_interface         (string         name        ,
-							   direction_t    direction   ,
-							   localisation_t localisation);
+  public    : Interface_fifo *      set_interface         (string         name        
+#ifdef POSITION
+							   ,direction_t    direction   
+							   ,localisation_t localisation
+#endif
+							   );
+#ifdef POSITION
   public    : Interface_fifo *      set_interface         (string         name        ,
 							   direction_t    direction   ,
 							   localisation_t localisation,
 							   string         comment     );
+#endif
   private   : string                get_interface         (void);
+  public    :list<Interface_fifo*>* get_interface_list    (void);
 
 #ifdef VHDL
@@ -53,16 +59,20 @@
 #ifdef VHDL_TESTBENCH
   private   : uint32_t              get_cycle             (void);
-  private   : string                get_clock             (void);
+  private   : Signal *              get_clock             (void);
+  private   : Signal *              get_reset             (void);
 
   private   : void                  testbench_generate_file (void);
   public    : void                  testbench             (void);
   private   : string                testbench_body        (Vhdl           * & vhdl          ,
-							   string             counter_name  );
+							   string             counter_name  ,
+							   string             reset_name    );
 #endif
 
   public    : Interface_fifo  *     find_interface        (string name);
+  public    : Signal          *     find_signal           (string name);
+  public    : bool                  find_signal           (Signal * signal);
 
+#ifdef POSITION
   public    : XML                   toXML                 (void);
-#ifdef POSITION
   public    : XML                   toXML_mapping         (void);
 #endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Localisation.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Localisation.h	(revision 41)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Localisation.h	(revision 42)
@@ -1,2 +1,3 @@
+#ifdef POSITION
 #ifndef morpheo_behavioural_Localisation_h
 #define morpheo_behavioural_Localisation_h
@@ -26,2 +27,3 @@
 
 #endif
+#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Position.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Position.h	(revision 41)
+++ 	(revision )
@@ -1,69 +1,0 @@
-#ifdef POSITION
-#ifndef morpheo_behavioural_Position_h
-#define morpheo_behavioural_Position_h
-
-/*
- * $Id$
- *
- * [ Description ]
- * 
- */
-
-#include <stdint.h>
-#include <iostream>
-#include <list>
-#include "Behavioural/include/Entity.h"
-#include "Include/ToString.h"
-#include "Include/Debug.h"
-
-using namespace std;
-
-namespace morpheo              {
-namespace behavioural          {
-
-  class Position
-  {
-    // -----[ fields ]----------------------------------------------------
-  private   : Entity              * _entity        ;
-  private   : list<Entity *>      * _list_component;
-    
-    // -----[ methods ]---------------------------------------------------
-  public    :                       Position          (void);
-  public    :                       Position          (const Position & position);
-  public    :                       ~Position         ();
-
-  public    : Entity *              set_entity        (string        name   ,
-						       string        type   ,
-						       schema_t      schema );
-  private   : string                get_entity        (void);
-
-  public    : void                  set_component     (Position * position,
-						       uint32_t   pos_x  ,
-						       uint32_t   pos_y  ,
-						       uint32_t   size_x ,
-						       uint32_t   size_y );
-
-  private   : string                get_component     (void);
-
-  public    : void                  port_map          (string component1,
-						       string signal1   ,
-						       string component2,
-						       string signal2   );
-
-  public    : XML                   toXML             (void);
-
-  private   : Entity *              find_entity       (string name);
-  private   : Interface *           find_interface    (string   name  , 
-						       Entity * entity);
-
-  public    : void                  generate_file     (void);
-    
-  public    : friend ostream&       operator<<        (ostream& output_stream,
-  					  	       morpheo::behavioural::Position & x);
-  };
-
-}; // end namespace behavioural          
-}; // end namespace morpheo              
-
-#endif
-#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Signal.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Signal.h	(revision 41)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Signal.h	(revision 42)
@@ -44,5 +44,7 @@
 		PORT_VHDL_NO_TESTBENCH_NO  ,
 		CLOCK_VHDL_YES             ,
-		CLOCK_VHDL_NO              } presence_port_t;
+		CLOCK_VHDL_NO              ,
+		RESET_VHDL_YES             ,
+		RESET_VHDL_NO              } presence_port_t;
 
   class Signal
@@ -56,8 +58,12 @@
   private   : const presence_port_t _presence_port;
 
+  private   : Signal *              _signal       ;
+  private   : bool                  _is_allocate  ;
+  private   : void *                _sc_signal    ;
+  private   : bool                  _is_map       ;
+  private   : void *                _sc_signal_map;
+  private   : type_info_t           _type_info    ;
+
 #ifdef VHDL_TESTBENCH
-  private   : void *                _signal       ;
-  private   : type_info_t           _type_info    ;
-
   private   : list<string>        * _list_value   ;
 #endif
@@ -71,5 +77,15 @@
   public    :                   ~Signal         ();
 
-#ifdef VHDL_TESTBENCH
+  public    : string            get_name        (void);
+  public    : uint32_t          get_size        (void);
+  public    : Signal *          get_signal_link (void);
+
+  public    : bool              presence_vhdl      (void);
+  public    : bool              presence_testbench (void);
+
+  public    : void              mapping         (Signal * signal);
+  public    : void              link            (Signal * signal);
+
+#ifdef SYSTEMC         
   public    :template <typename T>
              T                  read (void)
@@ -88,9 +104,9 @@
       switch (_type_info)
 	{
-	case BOOL     : return (static_cast<sc_in  <bool    > *>(_signal)->read()); 
-	case UINT8_T  : return (static_cast<sc_in  <uint8_t > *>(_signal)->read()); 
-	case UINT16_T : return (static_cast<sc_in  <uint16_t> *>(_signal)->read());
-	case UINT32_T : return (static_cast<sc_in  <uint32_t> *>(_signal)->read()); 
-	case UINT64_T : return (static_cast<sc_in  <uint64_t> *>(_signal)->read()); 
+	case BOOL     : return (static_cast<sc_in  <bool    > *>(_sc_signal_map)->read()); 
+	case UINT8_T  : return (static_cast<sc_in  <uint8_t > *>(_sc_signal_map)->read()); 
+	case UINT16_T : return (static_cast<sc_in  <uint16_t> *>(_sc_signal_map)->read());
+	case UINT32_T : return (static_cast<sc_in  <uint32_t> *>(_sc_signal_map)->read()); 
+	case UINT64_T : return (static_cast<sc_in  <uint64_t> *>(_sc_signal_map)->read()); 
 	default       : throw (ErrorMorpheo ("Signal \""+_name+"\" : type unknow."));
 	}
@@ -102,9 +118,9 @@
       switch (_type_info)
 	{
-	case BOOL     : return (static_cast<sc_out <bool    > *>(_signal)->read()); 
-	case UINT8_T  : return (static_cast<sc_out <uint8_t > *>(_signal)->read()); 
-	case UINT16_T : return (static_cast<sc_out <uint16_t> *>(_signal)->read());
-	case UINT32_T : return (static_cast<sc_out <uint32_t> *>(_signal)->read()); 
-	case UINT64_T : return (static_cast<sc_out <uint64_t> *>(_signal)->read()); 
+	case BOOL     : return (static_cast<sc_out <bool    > *>(_sc_signal_map)->read()); 
+	case UINT8_T  : return (static_cast<sc_out <uint8_t > *>(_sc_signal_map)->read()); 
+	case UINT16_T : return (static_cast<sc_out <uint16_t> *>(_sc_signal_map)->read());
+	case UINT32_T : return (static_cast<sc_out <uint32_t> *>(_sc_signal_map)->read()); 
+	case UINT64_T : return (static_cast<sc_out <uint64_t> *>(_sc_signal_map)->read()); 
 	default       : throw (ErrorMorpheo ("Signal \""+_name+"\" : type unknow."));
 	}
@@ -117,5 +133,7 @@
 	throw (ErrorMorpheo ("Signal \""+_name+"\" : already allocate."));
 
-      _signal    = port;
+      _is_allocate = true;
+      _sc_signal      = port;
+      _sc_signal_map  = port;
 
       if (typeid(T) == typeid(bool    ))
@@ -136,16 +154,21 @@
 	_type_info = UNKNOW;
     }
-
-  public    : void              testbench        (void);
-  public    : void              testbench_body   (Vhdl           * & vhdl          ,
-						  string             counter_name  );
-  public    : void              testbench_test_ok(Vhdl           * & vhdl          );
-#endif
+#endif
+
 #ifdef VHDL
   public    : void              set_port        (Vhdl * & vhdl);
 #  ifdef VHDL_TESTBENCH
-  public    : string            get_clock       (void);
+  public    : Signal *          get_clock       (void);
+  public    : Signal *          get_reset       (void);
+  public    : uint32_t          get_reset_cycle (bool active_low);
+
   public    : void              set_signal      (Vhdl * & vhdl);
   public    : void              get_name_vhdl   (list<string> * & list_signal);
+
+  public    : void              testbench        (void);
+  public    : void              testbench_body   (Vhdl           * & vhdl          ,
+						  string             counter_name  ,
+						  string             reset_name    );
+  public    : void              testbench_test_ok(Vhdl           * & vhdl          );
 #  endif
 #endif
@@ -162,8 +185,12 @@
     switch (x)
       {
-      case morpheo::behavioural::PORT_VHDL_YES_TESTBENCH_YES : return "Port is in VHDL's model and TestBench's model" ; break;
-      case morpheo::behavioural::PORT_VHDL_YES_TESTBENCH_NO  : return "Port is in VHDL's model                      " ; break;
-      case morpheo::behavioural::PORT_VHDL_NO_TESTBENCH_YES  : return "Port is in                  TestBench's model" ; break;
-      case morpheo::behavioural::PORT_VHDL_NO_TESTBENCH_NO   : return "Port is in none model                        " ; break;
+      case morpheo::behavioural::PORT_VHDL_YES_TESTBENCH_YES : return "Port  is in VHDL's model and TestBench's model" ; break;
+      case morpheo::behavioural::PORT_VHDL_YES_TESTBENCH_NO  : return "Port  is in VHDL's model                      " ; break;
+      case morpheo::behavioural::PORT_VHDL_NO_TESTBENCH_YES  : return "Port  is in                  TestBench's model" ; break;
+      case morpheo::behavioural::PORT_VHDL_NO_TESTBENCH_NO   : return "Port  is in none model                        " ; break;
+      case morpheo::behavioural::CLOCK_VHDL_YES              : return "Clock is in VHDL's model                     " ; break;
+      case morpheo::behavioural::CLOCK_VHDL_NO               : return "Clock is not in VHDL's model                 " ; break;
+      case morpheo::behavioural::RESET_VHDL_YES              : return "Reset is in VHDL's model                     " ; break;
+      case morpheo::behavioural::RESET_VHDL_NO               : return "Reset is not in VHDL's model                 " ; break;
       default                                                : return "";                                               break;
       }
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Vhdl_Testbench.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Vhdl_Testbench.h	(revision 41)
+++ 	(revision )
@@ -1,103 +1,0 @@
-#ifdef VHDL_TESTBENCH
-
-#ifndef morpheo_behavioural_Vhdl_Testbench_h
-#define morpheo_behavioural_Vhdl_Testbench_h
-
-/*
- * $Id$
- *
- * [ Description ]
- * 
- */
-
-#include "Behavioural/include/Environnement.h"
-#include "Behavioural/include/Vhdl.h"
-#include "Include/ToString.h"
-#include "Include/ToBase2.h"
-#include <stdint.h>
-#include <iostream>
-#include <list>
-
-using namespace std;
-
-namespace morpheo              {
-namespace behavioural          {
-
-  class Vhdl_Testbench
-  {
-    class label_t
-    {
-    public : const uint32_t _cycle;
-    public : const string   _label;
-
-      label_t (uint32_t cycle,
-	       string   label) :
-	_cycle (cycle),
-	_label (label)
-      {};
-    };
-
-//     // -----[ fields ]----------------------------------------------------
-//   private   : const string     _name       ;
-//   private   : const bool       _exhaustive ;
-
-//   private   : string           _clock_name ;
-//   private   : uint32_t         _num_cycle  ;
-
-//   private   : uint32_t         _size_input ;
-//   private   : uint32_t         _size_output;
-
-//   private   : list<string>     _list_input ;
-//   private   : list<string>     _list_input_cycle;
-//   private   : list<uint32_t>   _list_input_size ;
-
-//   private   : list<string>     _list_output;
-//   private   : list<string>     _list_output_cycle;
-//   private   : list<uint32_t>   _list_output_size ;
-
-//   private   : list<bool>       _list_test;
-//   private   : list<string>     _list_port;
-//   private   : list<label_t>    _list_label;
-
-//   private   : list<uint32_t>::iterator   _num_input ;
-//   private   : list<uint32_t>::iterator   _num_output;
-
-//   private   : Vhdl           * _vhdl;
-    
-    // -----[ methods ]---------------------------------------------------
-  public    :                  Vhdl_Testbench              (string   name,
-							    bool     exhaustive=true){};
-  public    :                  ~Vhdl_Testbench             (){};
-						           
-  public    : void             generate_file               (void){};
-
-  public    : void             set_port                    (string      name      ,
-							    direction_t direction ,
-							    uint32_t    size      ){};
-  public    : void             set_clock                   (string      name      ,
-							    bool        model_have_clock){};
-  public    : void             new_cycle                   (void){};
-
-  private   : uint32_t         get_input                   (void){return 0;};
-  private   : void             set_input                   (void){};
-  public    : void             add_input                   (uint32_t    value     ){};
-
-  private   : uint32_t         get_output                  (void){return 0;};
-  private   : void             set_output                  (void){};
-  public    : void             add_output                  (uint32_t    value     ){};
-
-  private   : uint32_t         get_test                    (void){return 0;};
-  public    : void             add_test                    (bool        must_test ){};
-
-  private   : void             get_label                   (void){};
-  public    : void             add_label                   (string      label     ){};
-
-  private   : void             generate_process_clock      (uint32_t    counter   ){};
-  private   : void             generate_instance           (void){};
-  };
-
-}; // end namespace behavioural          
-}; // end namespace morpheo              
-
-#endif
-#endif